Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.usermodel
Class XSSFWorkbook

    java.lang.Object
      org.apache.poi.POIXMLDocumentPart
          org.apache.poi.POIXMLDocument
              org.apache.poi.xssf.usermodel.XSSFWorkbook

All Implemented Interfaces:
  java.lang.Iterable<XSSFSheet>, Workbook

    public class XSSFWorkbook

extends POIXMLDocument
implements Workbook, java.lang.Iterable<XSSFSheet>

High level representation of a SpreadsheetML workbook. This is the first object most users will construct whether they are reading or writing a workbook. It is also the top level object for creating new sheets/etc.

Field Summary
`static float` | `DEFAULT_CHARACTER_WIDTH` Width of one character of the default font in pixels.

Fields inherited from class org.apache.poi.POIXMLDocument
`DOCUMENT_CREATOR, OLE_OBJECT_REL_TYPE, PACK_OBJECT_REL_TYPE`

Fields inherited from class org.apache.poi.POIXMLDocumentPart
`DEFAULT_XML_OPTIONS`

Fields inherited from interface org.apache.poi.ss.usermodel.Workbook
`PICTURE_TYPE_DIB, PICTURE_TYPE_EMF, PICTURE_TYPE_JPEG, PICTURE_TYPE_PICT, PICTURE_TYPE_PNG, PICTURE_TYPE_WMF, SHEET_STATE_HIDDEN, SHEET_STATE_VERY_HIDDEN, SHEET_STATE_VISIBLE`

Constructor Summary
`XSSFWorkbook()` Create a new SpreadsheetML workbook.
`XSSFWorkbook(java.io.InputStream is)`
`XSSFWorkbook(OPCPackage pkg)` Constructs a XSSFWorkbook object given a OpenXML4J `Package` object, see www.openxml4j.org.
`XSSFWorkbook(java.lang.String path)` Constructs a XSSFWorkbook object given a file name.

Method Summary
`int` | `addPicture(byte[] pictureData, int format)` Adds a picture to the workbook.
`int` | `addPicture(java.io.InputStream is, int format)` Adds a picture to the workbook.
`XSSFSheet` | `cloneSheet(int sheetNum)` Create an XSSFSheet from an existing sheet in the XSSFWorkbook.
`protected void` | `commit()` Save the content in the underlying package part.
`XSSFCellStyle` | `createCellStyle()` Create a new XSSFCellStyle and add it to the workbook's style table
`XSSFDataFormat` | `createDataFormat()` Returns the instance of XSSFDataFormat for this workbook.
`protected XSSFDialogsheet` | `createDialogsheet(java.lang.String sheetname, org.openxmlformats.schemas.spreadsheetml.x2006.main.CTDialogsheet dialogsheet)`
`XSSFFont` | `createFont()` Create a new Font and add it to the workbook's font table
`XSSFName` | `createName()` Creates a new (uninitialised) defined name in this workbook
`XSSFSheet` | `createSheet()` Create an XSSFSheet for this workbook, adds it to the sheets and returns the high level representation.
`XSSFSheet` | `createSheet(java.lang.String sheetname)` Create an XSSFSheet for this workbook, adds it to the sheets and returns the high level representation.
`XSSFFont` | `findFont(short boldWeight, short color, short fontHeight, java.lang.String name, boolean italic, boolean strikeout, short typeOffset, byte underline)` Finds a font that matches the one with the supplied attributes
`int` | `getActiveSheetIndex()` Convenience method to get the active sheet.
`java.util.List<PackagePart>` | `getAllEmbedds()` Get the document's embedded files.
`java.util.List<XSSFPictureData>` | `getAllPictures()` Gets all pictures from the Workbook.
`CalculationChain` | `getCalculationChain()` Return the CalculationChain object for this workbook
`XSSFCellStyle` | `getCellStyleAt(short idx)` gGet the cell style object at the given index
`XSSFCreationHelper` | `getCreationHelper()` Returns an object that handles instantiating concrete classes of the various instances for XSSF.
`org.openxmlformats.schemas.spreadsheetml.x2006.main.CTWorkbook` | `getCTWorkbook()` Return the underlying XML bean
`java.util.Collection<XSSFMap>` | `getCustomXMLMappings()`
`int` | `getFirstVisibleTab()` Gets the first tab that is displayed in the list of tabs in excel.
`XSSFFont` | `getFontAt(short idx)` Get the font at the given index number
`MapInfo` | `getMapInfo()`
`Row.MissingCellPolicy` | `getMissingCellPolicy()` Retrieves the current policy on what to do when getting missing or blank cells from a row.
`XSSFName` | `getName(java.lang.String name)`
`XSSFName` | `getNameAt(int nameIndex)`
`int` | `getNameIndex(java.lang.String name)` Gets the named range index by his name Note:Excel named ranges are case-insensitive and this method performs a case-insensitive search.
`short` | `getNumberOfFonts()` Get the number of fonts in the this workbook
`int` | `getNumberOfNames()` Get the number of named ranges in the this workbook
`int` | `getNumberOfSheets()` Get the number of worksheets in the this workbook
`short` | `getNumCellStyles()` Get the number of styles the workbook contains
`java.lang.String` | `getPrintArea(int sheetIndex)` Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.
`SharedStringsTable` | `getSharedStringSource()` Returns SharedStringsTable - tha cache of string for this workbook
`XSSFSheet` | `getSheet(java.lang.String name)` Get sheet with the given name (case insensitive match)
`XSSFSheet` | `getSheetAt(int index)` Get the XSSFSheet object at the given index.
`int` | `getSheetIndex(Sheet sheet)` Returns the index of the given sheet
`int` | `getSheetIndex(java.lang.String name)` Returns the index of the sheet by his name (case insensitive match)
`java.lang.String` | `getSheetName(int sheetIx)` Get the sheet name
`StylesTable` | `getStylesSource()` Return a object representing a collection of shared objects used for styling content, e.g.
`ThemesTable` | `getTheme()` Returns the Theme of current workbook.
`protected boolean` | `isDate1904()` Gets a boolean value that indicates whether the date systems used in the workbook starts in 1904.
`boolean` | `isHidden()`
`boolean` | `isMacroEnabled()` Are we a normal workbook (.xlsx), or a macro enabled workbook (.xlsm)?
`boolean` | `isRevisionLocked()` Specifies a boolean value that indicates whether the workbook is locked for revisions.
`boolean` | `isSheetHidden(int sheetIx)` Check whether a sheet is hidden.
`boolean` | `isSheetVeryHidden(int sheetIx)` Check whether a sheet is very hidden.
`boolean` | `isStructureLocked()` Specifies a boolean value that indicates whether structure of workbook is locked.
`boolean` | `isWindowsLocked()` Specifies a boolean value that indicates whether the windows that comprise the workbook are locked.
`java.util.Iterator<XSSFSheet>` | `iterator()` Allows foreach loops:
`void` | `lockRevision()` Locks the workbook for revisions.
`void` | `lockStructure()` Locks the structure of workbook.
`void` | `lockWindows()` Locks the windows that comprise the workbook.
`protected static OPCPackage` | `newPackage()` Create a new SpreadsheetML package and setup the default minimal content
`protected void` | `onDeleteFormula(XSSFCell cell)` Fired when a formula is deleted from this workbook, for example when calling cell.setCellFormula(null)
`protected void` | `onDocumentRead()` Fired when a package part is read
`void` | `removeName(int nameIndex)` Remove the defined name at the specified index
`void` | `removeName(java.lang.String name)` Remove a defined name by name
`void` | `removePrintArea(int sheetIndex)` Delete the printarea for the sheet specified
`void` | `removeSheetAt(int index)` Removes sheet at the given index. Care must be taken if the removed sheet is the currently active or only selected sheet in the workbook.
`void` | `setActiveSheet(int index)` Convenience method to set the active sheet.
`void` | `setFirstVisibleTab(int index)` Sets the first tab that is displayed in the list of tabs in excel.
`void` | `setHidden(boolean hiddenFlag)`
`void` | `setMissingCellPolicy(Row.MissingCellPolicy missingCellPolicy)` Sets the policy on what to do when getting missing or blank cells from a row.
`void` | `setPrintArea(int sheetIndex, int startColumn, int endColumn, int startRow, int endRow)` For the Convenience of Java Programmers maintaining pointers.
`void` | `setPrintArea(int sheetIndex, java.lang.String reference)` Sets the printarea for the sheet provided
`void` | `setRepeatingRowsAndColumns(int sheetIndex, int startColumn, int endColumn, int startRow, int endRow)` Sets the repeating rows and columns for a sheet.
`void` | `setSelectedTab(int index)` We only set one sheet as selected for compatibility with HSSF.
`void` | `setSheetHidden(int sheetIx, boolean hidden)` Sets the visible state of this sheet.
`void` | `setSheetHidden(int sheetIx, int state)` Hide or unhide a sheet.
`void` | `setSheetName(int sheet, java.lang.String name)` Set the sheet name.
`void` | `setSheetOrder(java.lang.String sheetname, int pos)` sets the order of appearance for a given sheet.
`void` | `unLockRevision()` Unlocks the workbook for revisions.
`void` | `unLockStructure()` Unlocks the structure of workbook.
`void` | `unLockWindows()` Unlocks the windows that comprise the workbook.

Methods inherited from class org.apache.poi.POIXMLDocument
`getCorePart, getPackage, getProperties, getRelatedByType, getTargetPart, getTargetPart, hasOOXMLHeader, load, openPackage, write`

Methods inherited from class org.apache.poi.POIXMLDocumentPart
`addRelation, createRelationship, createRelationship, createRelationship, getPackagePart, getPackageRelationship, getParent, getRelations, onDocumentCreate, onSave, read, rebase, removeRelation, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.poi.ss.usermodel.Workbook
`write`

Field Detail

### DEFAULT_CHARACTER_WIDTH

    public static final float DEFAULT_CHARACTER_WIDTH

  Width of one character of the default font in pixels. Same for Calibry and Arial.

  See Also:
    Constant Field Values

Constructor Detail

### XSSFWorkbook

    public XSSFWorkbook()

  Create a new SpreadsheetML workbook.

### XSSFWorkbook

    public XSSFWorkbook(OPCPackage pkg)
                 throws java.io.IOException

  Constructs a XSSFWorkbook object given a OpenXML4J `Package` object, see www.openxml4j.org.

  Parameters:
    `pkg` - the OpenXML4J `Package` object.
  Throws:
    `java.io.IOException`

### XSSFWorkbook

    public XSSFWorkbook(java.io.InputStream is)
                 throws java.io.IOException

Throws:
  `java.io.IOException`

### XSSFWorkbook

    public XSSFWorkbook(java.lang.String path)
                 throws java.io.IOException

  Constructs a XSSFWorkbook object given a file name.

  Parameters:
    `path` - the file name.
  Throws:
    `java.io.IOException`

Method Detail

### onDocumentRead

    protected void onDocumentRead()
                           throws java.io.IOException

  Description copied from class: `POIXMLDocumentPart`
  Fired when a package part is read

  Overrides:
    `onDocumentRead` in class `POIXMLDocumentPart`
  Throws:
    `java.io.IOException`

### newPackage

    protected static OPCPackage newPackage()

  Create a new SpreadsheetML package and setup the default minimal content

### getCTWorkbook

    @Internal
    public org.openxmlformats.schemas.spreadsheetml.x2006.main.CTWorkbook getCTWorkbook()

  Return the underlying XML bean

  Returns:
    the underlying CTWorkbook bean

### addPicture

    public int addPicture(byte[] pictureData,
                          int format)

  Adds a picture to the workbook.

  Specified by:
    `addPicture` in interface `Workbook`
  Parameters:
    `pictureData` - The bytes of the picture
    `format` - The format of the picture.
  Returns:
    the index to this picture (0 based), the added picture can be obtained from `getAllPictures()` .
  See Also:
    `Workbook.PICTURE_TYPE_EMF`, `Workbook.PICTURE_TYPE_WMF`, `Workbook.PICTURE_TYPE_PICT`, `Workbook.PICTURE_TYPE_JPEG`, `Workbook.PICTURE_TYPE_PNG`, `Workbook.PICTURE_TYPE_DIB`, `getAllPictures()`

### addPicture

    public int addPicture(java.io.InputStream is,
                          int format)
                   throws java.io.IOException

  Adds a picture to the workbook.

  Parameters:
    `is` - The sream to read image from
    `format` - The format of the picture.
  Returns:
    the index to this picture (0 based), the added picture can be obtained from `getAllPictures()` .
  Throws:
    `java.io.IOException`
  See Also:
    `Workbook.PICTURE_TYPE_EMF`, `Workbook.PICTURE_TYPE_WMF`, `Workbook.PICTURE_TYPE_PICT`, `Workbook.PICTURE_TYPE_JPEG`, `Workbook.PICTURE_TYPE_PNG`, `Workbook.PICTURE_TYPE_DIB`, `getAllPictures()`

### cloneSheet

    public XSSFSheet cloneSheet(int sheetNum)

  Create an XSSFSheet from an existing sheet in the XSSFWorkbook. The cloned sheet is a deep copy of the original.

  Specified by:
    `cloneSheet` in interface `Workbook`
  Returns:
    XSSFSheet representing the cloned sheet.
  Throws:
    `java.lang.IllegalArgumentException` - if the sheet index in invalid
    `POIXMLException` - if there were errors when cloning

### createCellStyle

    public XSSFCellStyle createCellStyle()

  Create a new XSSFCellStyle and add it to the workbook's style table

  Specified by:
    `createCellStyle` in interface `Workbook`
  Returns:
    the new XSSFCellStyle object

### createDataFormat

    public XSSFDataFormat createDataFormat()

  Returns the instance of XSSFDataFormat for this workbook.

  Specified by:
    `createDataFormat` in interface `Workbook`
  Returns:
    the XSSFDataFormat object
  See Also:
    `DataFormat`

### createFont

    public XSSFFont createFont()

  Create a new Font and add it to the workbook's font table

  Specified by:
    `createFont` in interface `Workbook`
  Returns:
    new font object

### createName

    public XSSFName createName()

  Description copied from interface: `Workbook`
  Creates a new (uninitialised) defined name in this workbook

  Specified by:
    `createName` in interface `Workbook`
  Returns:
    new defined name object

### createSheet

    public XSSFSheet createSheet()

  Create an XSSFSheet for this workbook, adds it to the sheets and returns the high level representation. Use this to create new sheets.

  Specified by:
    `createSheet` in interface `Workbook`
  Returns:
    XSSFSheet representing the new sheet.

### createSheet

    public XSSFSheet createSheet(java.lang.String sheetname)

  Create an XSSFSheet for this workbook, adds it to the sheets and returns the high level representation. Use this to create new sheets.

  Specified by:
    `createSheet` in interface `Workbook`
  Parameters:
    `sheetname` - sheetname to set for the sheet, can't be duplicate, greater than 31 chars or contain /\?*[]
  Returns:
    XSSFSheet representing the new sheet.
  Throws:
    `java.lang.IllegalArgumentException` - if the sheetname is invalid or the workbook already contains a sheet of this name

### createDialogsheet

    protected XSSFDialogsheet createDialogsheet(java.lang.String sheetname,
                                                org.openxmlformats.schemas.spreadsheetml.x2006.main.CTDialogsheet dialogsheet)

### findFont

    public XSSFFont findFont(short boldWeight,
                             short color,
                             short fontHeight,
                             java.lang.String name,
                             boolean italic,
                             boolean strikeout,
                             short typeOffset,
                             byte underline)

  Finds a font that matches the one with the supplied attributes

  Specified by:
    `findFont` in interface `Workbook`
  Returns:
    the font with the matched attributes or `null`

### getActiveSheetIndex

    public int getActiveSheetIndex()

  Convenience method to get the active sheet. The active sheet is is the sheet which is currently displayed when the workbook is viewed in Excel. 'Selected' sheet(s) is a distinct concept.

  Specified by:
    `getActiveSheetIndex` in interface `Workbook`
  Returns:
    the index of the active sheet (0-based)

### getAllPictures

    public java.util.List<XSSFPictureData> getAllPictures()

  Gets all pictures from the Workbook.

  Specified by:
    `getAllPictures` in interface `Workbook`
  Returns:
    the list of pictures (a list of `XSSFPictureData` objects.)
  See Also:
    `addPicture(byte[], int)`

### getCellStyleAt

    public XSSFCellStyle getCellStyleAt(short idx)

  gGet the cell style object at the given index

  Specified by:
    `getCellStyleAt` in interface `Workbook`
  Parameters:
    `idx` - index within the set of styles
  Returns:
    XSSFCellStyle object at the index

### getFontAt

    public XSSFFont getFontAt(short idx)

  Get the font at the given index number

  Specified by:
    `getFontAt` in interface `Workbook`
  Parameters:
    `idx` - index number
  Returns:
    XSSFFont at the index

### getName

    public XSSFName getName(java.lang.String name)

  Specified by:
    `getName` in interface `Workbook`
  Parameters:
    `name` - the name of the defined name
  Returns:
    the defined name with the specified name. `null` if not found.

### getNameAt

    public XSSFName getNameAt(int nameIndex)

  Specified by:
    `getNameAt` in interface `Workbook`
  Parameters:
    `nameIndex` - position of the named range (0-based)
  Returns:
    the defined name at the specified index

### getNameIndex

    public int getNameIndex(java.lang.String name)

  Gets the named range index by his name Note:Excel named ranges are case-insensitive and this method performs a case-insensitive search.

  Specified by:
    `getNameIndex` in interface `Workbook`
  Parameters:
    `name` - named range name
  Returns:
    named range index

### getNumCellStyles

    public short getNumCellStyles()

  Get the number of styles the workbook contains

  Specified by:
    `getNumCellStyles` in interface `Workbook`
  Returns:
    count of cell styles

### getNumberOfFonts

    public short getNumberOfFonts()

  Get the number of fonts in the this workbook

  Specified by:
    `getNumberOfFonts` in interface `Workbook`
  Returns:
    number of fonts

### getNumberOfNames

    public int getNumberOfNames()

  Get the number of named ranges in the this workbook

  Specified by:
    `getNumberOfNames` in interface `Workbook`
  Returns:
    number of named ranges

### getNumberOfSheets

    public int getNumberOfSheets()

  Get the number of worksheets in the this workbook

  Specified by:
    `getNumberOfSheets` in interface `Workbook`
  Returns:
    number of worksheets

### getPrintArea

    public java.lang.String getPrintArea(int sheetIndex)

  Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.

  Specified by:
    `getPrintArea` in interface `Workbook`
  Parameters:
    `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
  Returns:
    String Null if no print area has been defined

### getSheet

    public XSSFSheet getSheet(java.lang.String name)

  Get sheet with the given name (case insensitive match)

  Specified by:
    `getSheet` in interface `Workbook`
  Parameters:
    `name` - of the sheet
  Returns:
    XSSFSheet with the name provided or `null` if it does not exist

### getSheetAt

    public XSSFSheet getSheetAt(int index)

  Get the XSSFSheet object at the given index.

  Specified by:
    `getSheetAt` in interface `Workbook`
  Parameters:
    `index` - of the sheet number (0-based physical & logical)
  Returns:
    XSSFSheet at the provided index
  Throws:
    `java.lang.IllegalArgumentException` - if the index is out of range (index < 0 || index >= getNumberOfSheets()).

### getSheetIndex

    public int getSheetIndex(java.lang.String name)

  Returns the index of the sheet by his name (case insensitive match)

  Specified by:
    `getSheetIndex` in interface `Workbook`
  Parameters:
    `name` - the sheet name
  Returns:
    index of the sheet (0 based) or `-1`

  ### getSheetIndex

      public int getSheetIndex(Sheet sheet)

    Returns the index of the given sheet

    Specified by:
      `getSheetIndex` in interface `Workbook`
    Parameters:
      `sheet` - the sheet to look up
    Returns:
      index of the sheet (0 based). `-1` if not found

  ### getSheetName

      public java.lang.String getSheetName(int sheetIx)

    Get the sheet name

    Specified by:
      `getSheetName` in interface `Workbook`
    Parameters:
      `sheetIx` - Number
    Returns:
      Sheet name

  ### iterator

      public java.util.Iterator<XSSFSheet> iterator()

    Allows foreach loops:

         XSSFWorkbook wb = new XSSFWorkbook(package);
         for(XSSFSheet sheet : wb){

         }

    Specified by:
      `iterator` in interface `java.lang.Iterable<XSSFSheet>`

  ### isMacroEnabled

      public boolean isMacroEnabled()

    Are we a normal workbook (.xlsx), or a macro enabled workbook (.xlsm)?

  ### removeName

      public void removeName(int nameIndex)

    Description copied from interface: `Workbook`
    Remove the defined name at the specified index

    Specified by:
      `removeName` in interface `Workbook`
    Parameters:
      `nameIndex` - named range index (0 based)

  ### removeName

      public void removeName(java.lang.String name)

    Description copied from interface: `Workbook`
    Remove a defined name by name

    Specified by:
      `removeName` in interface `Workbook`
    Parameters:
      `name` - the name of the defined name

  ### removePrintArea

      public void removePrintArea(int sheetIndex)

    Delete the printarea for the sheet specified

    Specified by:
      `removePrintArea` in interface `Workbook`
    Parameters:
      `sheetIndex` - 0-based sheet index (0 = First Sheet)

  ### removeSheetAt

      public void removeSheetAt(int index)

    Removes sheet at the given index.

    Care must be taken if the removed sheet is the currently active or only selected sheet in the workbook. There are a few situations when Excel must have a selection and/or active sheet. (For example when printing - see Bug 40414).
    This method makes sure that if the removed sheet was active, another sheet will become active in its place. Furthermore, if the removed sheet was the only selected sheet, another sheet will become selected. The newly active/selected sheet will have the same index, or one less if the removed sheet was the last in the workbook.

    Specified by:
      `removeSheetAt` in interface `Workbook`
    Parameters:
      `index` - of the sheet (0-based)

  ### getMissingCellPolicy

      public Row.MissingCellPolicy getMissingCellPolicy()

    Retrieves the current policy on what to do when getting missing or blank cells from a row. The default is to return blank and null cells. `Row.MissingCellPolicy`

    Specified by:
      `getMissingCellPolicy` in interface `Workbook`

  ### setMissingCellPolicy

      public void setMissingCellPolicy(Row.MissingCellPolicy missingCellPolicy)

    Sets the policy on what to do when getting missing or blank cells from a row. This will then apply to all calls to `Row.getCell(int)`}. See `Row.MissingCellPolicy`

    Specified by:
      `setMissingCellPolicy` in interface `Workbook`

  ### setActiveSheet

      public void setActiveSheet(int index)

    Convenience method to set the active sheet. The active sheet is is the sheet which is currently displayed when the workbook is viewed in Excel. 'Selected' sheet(s) is a distinct concept.

    Specified by:
      `setActiveSheet` in interface `Workbook`
    Parameters:
      `index` - index of the active sheet (0-based)

  ### getFirstVisibleTab

      public int getFirstVisibleTab()

    Gets the first tab that is displayed in the list of tabs in excel.

    Specified by:
      `getFirstVisibleTab` in interface `Workbook`
    Returns:
      integer that contains the index to the active sheet in this book view.

  ### setFirstVisibleTab

      public void setFirstVisibleTab(int index)

    Sets the first tab that is displayed in the list of tabs in excel.

    Specified by:
      `setFirstVisibleTab` in interface `Workbook`
    Parameters:
      `index` - integer that contains the index to the active sheet in this book view.

  ### setPrintArea

      public void setPrintArea(int sheetIndex,
                               java.lang.String reference)

    Sets the printarea for the sheet provided

    i.e. Reference = $A$1:$B$2

    Specified by:
      `setPrintArea` in interface `Workbook`
    Parameters:
      `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
      `reference` - Valid name Reference for the Print Area

  ### setPrintArea

      public void setPrintArea(int sheetIndex,
                               int startColumn,
                               int endColumn,
                               int startRow,
                               int endRow)

    For the Convenience of Java Programmers maintaining pointers.

    Specified by:
      `setPrintArea` in interface `Workbook`
    Parameters:
      `sheetIndex` - Zero-based sheet index (0 = First Sheet)
      `startColumn` - Column to begin printarea
      `endColumn` - Column to end the printarea
      `startRow` - Row to begin the printarea
      `endRow` - Row to end the printarea
    See Also:
      `setPrintArea(int, String)`

  ### setRepeatingRowsAndColumns

      public void setRepeatingRowsAndColumns(int sheetIndex,
                                             int startColumn,
                                             int endColumn,
                                             int startRow,
                                             int endRow)

    Sets the repeating rows and columns for a sheet.

    To set just repeating columns:

          workbook.setRepeatingRowsAndColumns(0,0,1,-1,-1);

    To set just repeating rows:

          workbook.setRepeatingRowsAndColumns(0,-1,-1,0,4);

    To remove all repeating rows and columns for a sheet.

          workbook.setRepeatingRowsAndColumns(0,-1,-1,-1,-1);

    Specified by:
      `setRepeatingRowsAndColumns` in interface `Workbook`
    Parameters:
      `sheetIndex` - 0 based index to sheet.
      `startColumn` - 0 based start of repeating columns.
      `endColumn` - 0 based end of repeating columns.
      `startRow` - 0 based start of repeating rows.
      `endRow` - 0 based end of repeating rows.

  ### setSelectedTab

      public void setSelectedTab(int index)

    We only set one sheet as selected for compatibility with HSSF.

    Specified by:
      `setSelectedTab` in interface `Workbook`
    Parameters:
      `index` - the index of the sheet to select (0 based)
    See Also:
      `Sheet.setSelected(boolean)`

  ### setSheetName

      public void setSheetName(int sheet,
                               java.lang.String name)

    Set the sheet name. Will throw IllegalArgumentException if the name is greater than 31 chars or contains /\?*[]

    Specified by:
      `setSheetName` in interface `Workbook`
    Parameters:
      `sheet` - number (0 based)

  ### setSheetOrder

      public void setSheetOrder(java.lang.String sheetname,
                                int pos)

    sets the order of appearance for a given sheet.

    Specified by:
      `setSheetOrder` in interface `Workbook`
    Parameters:
      `sheetname` - the name of the sheet to reorder
      `pos` - the position that we want to insert the sheet into (0 based)

  ### commit

      protected void commit()
                     throws java.io.IOException

    Description copied from class: `POIXMLDocumentPart`
    Save the content in the underlying package part. Default implementation is empty meaning that the package part is left unmodified. Sub-classes should override and add logic to marshal the "model" into Ooxml4J. For example, the code saving a generic XML entry may look as follows:

         protected void commit() throws IOException {
           PackagePart part = getPackagePart();
           OutputStream out = part.getOutputStream();
           XmlObject bean = getXmlBean(); //the "model" which holds changes in memory
           bean.save(out, DEFAULT_XML_OPTIONS);
           out.close();
         }

    Overrides:
      `commit` in class `POIXMLDocumentPart`
    Throws:
      `java.io.IOException`

  ### getSharedStringSource

      @Internal
      public SharedStringsTable getSharedStringSource()

    Returns SharedStringsTable - tha cache of string for this workbook

    Returns:
      the shared string table

  ### getStylesSource

      public StylesTable getStylesSource()

    Return a object representing a collection of shared objects used for styling content, e.g. fonts, cell styles, colors, etc.

  ### getTheme

      public ThemesTable getTheme()

    Returns the Theme of current workbook.

  ### getCreationHelper

      public XSSFCreationHelper getCreationHelper()

    Returns an object that handles instantiating concrete classes of the various instances for XSSF.

    Specified by:
      `getCreationHelper` in interface `Workbook`

  ### isDate1904

      protected boolean isDate1904()

    Gets a boolean value that indicates whether the date systems used in the workbook starts in 1904.

    The default value is false, meaning that the workbook uses the 1900 date system, where 1/1/1900 is the first day in the system..

    Returns:
      true if the date systems used in the workbook starts in 1904

  ### getAllEmbedds

      public java.util.List<PackagePart> getAllEmbedds()
                                                throws OpenXML4JException

    Get the document's embedded files.

    Specified by:
      `getAllEmbedds` in class `POIXMLDocument`
    Throws:
      `OpenXML4JException`

  ### isHidden

      public boolean isHidden()

    Specified by:
      `isHidden` in interface `Workbook`
    Returns:
      `false` if this workbook is not visible in the GUI

  ### setHidden

      public void setHidden(boolean hiddenFlag)

    Specified by:
      `setHidden` in interface `Workbook`
    Parameters:
      `hiddenFlag` - pass `false` to make the workbook visible in the GUI

  ### isSheetHidden

      public boolean isSheetHidden(int sheetIx)

    Check whether a sheet is hidden.

    Note that a sheet could instead be set to be very hidden, which is different (`isSheetVeryHidden(int)`)

    Specified by:
      `isSheetHidden` in interface `Workbook`
    Parameters:
      `sheetIx` - Number
    Returns:
      `true` if sheet is hidden

  ### isSheetVeryHidden

      public boolean isSheetVeryHidden(int sheetIx)

    Check whether a sheet is very hidden.

    This is different from the normal hidden status (`isSheetHidden(int)`)

    Specified by:
      `isSheetVeryHidden` in interface `Workbook`
    Parameters:
      `sheetIx` - sheet index to check
    Returns:
      `true` if sheet is very hidden

  ### setSheetHidden

      public void setSheetHidden(int sheetIx,
                                 boolean hidden)

    Sets the visible state of this sheet.

    Calling `setSheetHidden(sheetIndex, true)` is equivalent to `setSheetHidden(sheetIndex, Workbook.SHEET_STATE_HIDDEN)`.
    Calling `setSheetHidden(sheetIndex, false)` is equivalent to `setSheetHidden(sheetIndex, Workbook.SHEET_STATE_VISIBLE)`.

    Specified by:
      `setSheetHidden` in interface `Workbook`
    Parameters:
      `sheetIx` - the 0-based index of the sheet
      `hidden` - whether this sheet is hidden
    See Also:
      `setSheetHidden(int, int)`

  ### setSheetHidden

      public void setSheetHidden(int sheetIx,
                                 int state)

    Hide or unhide a sheet.
    - 0 - visible.
    - 1 - hidden.
    - 2 - very hidden.

    Specified by:
      `setSheetHidden` in interface `Workbook`
    Parameters:
      `sheetIx` - the sheet index (0-based)
      `state` - one of the following `Workbook` constants: `Workbook.SHEET_STATE_VISIBLE`, `Workbook.SHEET_STATE_HIDDEN`, or `Workbook.SHEET_STATE_VERY_HIDDEN`.
    Throws:
      `java.lang.IllegalArgumentException` - if the supplied sheet index or state is invalid

  ### onDeleteFormula

      protected void onDeleteFormula(XSSFCell cell)

    Fired when a formula is deleted from this workbook, for example when calling cell.setCellFormula(null)

    See Also:
      `XSSFCell.setCellFormula(String)`

  ### getCalculationChain

      @Internal
      public CalculationChain getCalculationChain()

    Return the CalculationChain object for this workbook

    The calculation chain object specifies the order in which the cells in a workbook were last calculated

    Returns:
      the `CalculationChain` object or `null` if not defined

  ### getCustomXMLMappings

      public java.util.Collection<XSSFMap> getCustomXMLMappings()

    Returns:
      a collection of custom XML mappings defined in this workbook

  ### getMapInfo

      @Internal
      public MapInfo getMapInfo()

    Returns:
      the helper class used to query the custom XML mapping defined in this workbook

  ### isStructureLocked

      public boolean isStructureLocked()

    Specifies a boolean value that indicates whether structure of workbook is locked.
    A value true indicates the structure of the workbook is locked. Worksheets in the workbook can't be moved, deleted, hidden, unhidden, or renamed, and new worksheets can't be inserted.
    A value of false indicates the structure of the workbook is not locked.

    Returns:
      true if structure of workbook is locked

  ### isWindowsLocked

      public boolean isWindowsLocked()

    Specifies a boolean value that indicates whether the windows that comprise the workbook are locked.
    A value of true indicates the workbook windows are locked. Windows are the same size and position each time the workbook is opened.
    A value of false indicates the workbook windows are not locked.

    Returns:
      true if windows that comprise the workbook are locked

  ### isRevisionLocked

      public boolean isRevisionLocked()

    Specifies a boolean value that indicates whether the workbook is locked for revisions.

    Returns:
      true if the workbook is locked for revisions.

  ### lockStructure

      public void lockStructure()

    Locks the structure of workbook.

  ### unLockStructure

      public void unLockStructure()

    Unlocks the structure of workbook.

  ### lockWindows

      public void lockWindows()

    Locks the windows that comprise the workbook.

  ### unLockWindows

      public void unLockWindows()

    Unlocks the windows that comprise the workbook.

  ### lockRevision

      public void lockRevision()

    Locks the workbook for revisions.

  ### unLockRevision

      public void unLockRevision()

    Unlocks the workbook for revisions.

  Overview | Package | Class | Use | Tree | Deprecated | Index | Help
  PREV CLASS NEXT CLASS | FRAMES NO FRAMES
  SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

  Copyright 2010 The Apache Software Foundation or its licensors, as applicable.